// Compile with:
// c++ -fPIC -o ept-test main.cpp

void foo(int a);

struct string
{
    string() {}
    ~string() { }

    void operator=(int a)
    {
    	foo(a);
    }
};


/* struct A {
    A() {}
}; */
typedef int A; // segfault both ways: int, empty struct

struct B
{
    A &a;
    int b; // removed -> no segfault
    B( A &_a ) : a( _a ) {}
};

struct T
{
    A a;
    B b;
    string t;

    T() : b( a ) {}

    void broken() {
	 t = 1;
    }
};

void runBroken() { T().broken(); }

int main( int argc, char **argv ) {
	runBroken(); // when T().broken() is used, no segfault
	return 0;
}
